package cn.com.ctop.kuaishou.modules.batch.service.impl;

import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.HttpUtils;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouVideoTimeService;
import cn.com.ctop.kuaishou.modules.report.entity.KuaishouAgentAccount;
import cn.com.ctop.kuaishou.modules.report.service.IKuaishouAgentAccountService;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Slf4j
@Service
public class KuaiShouVideoTimeServiceImpl implements IKuaiShouVideoTimeService {
    @Autowired
    private IKuaishouAgentAccountService agentAccountService;

    @Override
    public java.util.Date getVideoTime(String photoId, Long accountId) {

        KuaishouAgentAccount agentAccount = agentAccountService.getById(accountId);
        if (Check.isNull(agentAccount)) {
            log.info("未获取到userId:accountId:{}",accountId);
            return null;
        }

        try {
            String videoUrl = "http://yongzhou.s.gifshow.com/i/photo/lwx?userId=" + agentAccount.getUserId() + "&photoId=" + photoId;
            String res = HttpUtils.getKuaishouShareUrl(videoUrl);
            String path = res.split("\\?")[0];
            String photoIdStr = path.substring(path.lastIndexOf("/") + 1, path.length());
            path = path.substring(0, path.lastIndexOf("/"));
            String uid = path.substring(path.lastIndexOf("/") + 1, path.length());
            String result = HttpUtils.postKuaishouVideoUrl("https://live.kuaishou.com/m_graphql", uid, photoIdStr);
            JSONObject resultJson = JSONObject.parseObject(result);
            if (!Check.isNull(resultJson)) {
                JSONObject dataJson = resultJson.getJSONObject("data");
                if (!Check.isNull(dataJson)) {
                    JSONObject feedById = dataJson.getJSONObject("feedById");
                    if (!Check.isNull(feedById)) {
                        JSONObject currentWork = feedById.getJSONObject("currentWork");
                        if (!Check.isNull(currentWork)) {
                            Long timestamp = currentWork.getLong("timestamp");
                            return new java.util.Date(timestamp);

                        }

                    }

                }

            }

        } catch (Exception e) {
            e.printStackTrace();
            log.error("获取时间错误");
        }


        return null;
    }
}
